using System;
using System.Collections.Generic;

namespace ConsoleApplication2
{

    class Program
    {      
        static void Main(string[] args)
        {
            int f = 0;
            List<long> a = new List<long>();
            List<long> b = new List<long>();
            int t = int.Parse(Console.ReadLine());
            for(int i=0;i<t;i++)
            {
                var s = Console.ReadLine().Split();
                int n = int.Parse(s[0]);
                int m = int.Parse(s[1]);
                var s1 = Console.ReadLine().Split();
                for (int j=0;j<n;j++)
                {
                    a.Add(long.Parse(s1[j]));
                }
                var s2 = Console.ReadLine().Split();
                for(int j=0;j<m;j++)
                {
                    long d = long.Parse(s2[j]);
                }
                a.Sort();
                if(n!=2)
                {             
                for(int j=1;j<n;j++)
                {
                    if(a[j]%3!=a[j-1]%3)
                    {
                        b.Add(0);
                        a.Clear();
                        f = 1;
                        break;
                    }
                }
                }
                if (f!=1)
                {
                b.Add(1);
                a.Clear();
                }
                f = 0;
            }
            for(int i=0;i<b.Count;i++)
                Console.WriteLine(b[i]);
        }
    }
}